# 82. Query: Restore Subscription Events

There is always a good practice to have the possibility to restore/recheck the delivered vs produced subscription events. Therefore GeoPard stores the history of all produced subscription events for the **last 12 months**.&#x20;

The common cases:&#x20;

* Bad internet connection and events were not delivered
* Redeployment of the WebSocket listener
* Check the consistency received vs produced events

{% code overflow="wrap" lineNumbers="true" %}

```graphql
  getPlatformEvents(input: {
    dateFrom: "2023-05-25T12:49:00.000Z", 
    dateTo: "2023-05-30T06:35:00.000Z", 
    userUuids: ["<placeholder_of_user_uuid>"]
  }){
    events {
      executionDate
      event {
        uuid
        userUuid
        action
        nodePath {
          entity
          uuid
        }
      }
    } 
  }
}
```

{% endcode %}

Supported input filters:

* `dateFrom` as datetime in ISO 8701 format (ex: `"2023-05-25T12:49:00.000Z"`)
* `dateTo` as datetime in ISO 8701 format (ex: `"2023-05-30T06:35:00.000Z"`)
* `farmUuids` as array of "Farm" UUIDs to search
* `fieldUuids` as array of "Field" UUIDs to search&#x20;
* `userUuids` as array of "User" UUIDs to search
* `eventUuids` as array of subscription "Event" UUIDs

{% hint style="info" %}
All filters work like logical **AND**.
{% endhint %}

{% hint style="info" %}
Every subscription event has an attribute `executionDate` linked to the sent moment in the AWSDateTime format compatible with ISO 8601 DateTime.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.geopard.tech/geopard-tutorials/api-docs/geopard-api-requests-overview/82.-query-restore-subscription-events.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
